/*
 * platform.c
 *
 *  Created on: 2020年3月19日
 *      Author: bhliong.tw
 */

#include <stdio.h>
#include "platform.h"
#include "EcmUsrDriver.h"
#include "stm32f4xx_hal.h"
extern TIM_HandleTypeDef htim2;
extern SPI_HandleTypeDef hspi1;

/*************************************************
 * 
 * Local Bus module API 
 * 
 * **********************************************/
int XF_SetDevType(int nType){ return 1; }
int XF_GetDevType(){ return 1; }
int32_t UserGetGpioData_u32(unsigned long *pulVal){ return 0; }
int32_t UserSetGpioData_u32(unsigned long ulVal){ return 0; }
int32_t UserGetGpioDir(unsigned long *pulDir){ return 0; }
int32_t UserSetGpioDir(unsigned long ulDir){ return 0; }
int32_t UserSetGpioData(uint8_t u8Idx, unsigned long ulVal){ return 0; }
int32_t UserGetGpioData(uint8_t u8Idx, unsigned long *pulVal){ return 0; }

static __inline int ECMSPIReadWrite(uint8_t *rdata, uint8_t *wdata, int rwlength)
{
	HAL_GPIO_WritePin(GPIOB, GPIO_PIN_6, GPIO_PIN_RESET);
	HAL_SPI_TransmitReceive(&hspi1,wdata,rdata,rwlength,HAL_MAX_DELAY);
	HAL_GPIO_WritePin(GPIOB, GPIO_PIN_6, GPIO_PIN_SET);
	return 0;
}

int UserSys_Init(uint32_t u32SpiFreq)
{
	return 0;
}

void UserSys_Close(void)
{

}

int UserSpiDataExchange(uint8_t *pTxBuf, uint8_t *pRxBuf, uint32_t u32PackSize)
{
	ECMSPIReadWrite(pRxBuf, pTxBuf, u32PackSize);
	return 1;
}

unsigned int
crc32(const void *buf, size_t size);
uint32_t g_u32CrcType = ECM_CRC_TYPE_NONE;

int UserDelay(uint32_t uSec)
{
	uint32_t curTicks, dlyTicks, dlyCnt, tmcnt, stratcnt;
	dlyTicks = uSec/1000U;
	dlyCnt = uSec%1000U*84;//<<<<<<H7=64,F4=84

	curTicks = HAL_GetTick();
	while ((HAL_GetTick() - curTicks) < dlyTicks) { __NOP(); }

	stratcnt = htim2.Instance->CNT;
	do{
		tmcnt = htim2.Instance->CNT;
	}while( tmcnt - stratcnt < dlyCnt);

	return 1;
}

int usleep(unsigned long usec){
	UserDelay(usec);
	return 0;
}

unsigned sleep(unsigned int sec){
	int i = 0;
	for( ; i < sec; i++)
		UserDelay(1000000);
	return 0;
}
