#include <stdio.h>
#include "stm32f4xx_hal.h"

extern UART_HandleTypeDef huart2;

#if defined(__GNUC__)
int _write(int fd, char * ptr, int len)
{
  HAL_UART_Transmit(&huart2, (uint8_t *) ptr, len, HAL_MAX_DELAY);
  return len;
}

int _read (int fd, char *ptr, int len)
{
	HAL_UART_Receive( &huart2, (uint8_t *)ptr, 1, HAL_MAX_DELAY);
	return 1;
}

int fputc(int ch, FILE *stream)
{
	uint8_t c = ch & 0xff;
	HAL_UART_Transmit( &huart2, (uint8_t *)&c, 1, HAL_MAX_DELAY);
    return ch;
}

int fgetc(FILE *stream)
{
	uint8_t ch;
	HAL_UART_Receive( &huart2, (uint8_t *)&ch, 1, HAL_MAX_DELAY);
    return (ch);
}
#endif
